' Copyright (c) 2008  Future Technology Devices International Ltd.
'
' Module Name
'
'     MainForm.vb
'
' Abstract:
'
'    Visual Basic program, to test the FTCI2C.DLL. The FTCI2C.DLL is used to control the FT2232H dual hi-speed device
'    and the FT4232H quad hi-speed device to simulate the Inter-Integrated Circuit(I2C) synchronous protocol to
'    communicate with I2C devices connected to FT2232H dual hi-speed devices and FT4232H quad hi-speed devices.
'
' Revision History:
'
'   05/08/08    Kirke Ashton    Created.
'   03/09/08    Kirke Ashton    Added new thread to test updated FTCI2C.DLL, to ensure it can handle multiple threads.
'
Imports System
Imports System.Threading

Public Class MainForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Friend WithEvents DLLVersionLabel As System.Windows.Forms.Label
    Friend WithEvents GPIOL1To3GPIOH0To7OnlyCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH0InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH0OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH1InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH1OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH2InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH2OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH3InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH3OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents DeviceNameLabel As System.Windows.Forms.Label
    Friend WithEvents HiSpeedDeviceTypeGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents FT2232HRadioButton As System.Windows.Forms.RadioButton
    Friend WithEvents FT4232HRadioButton As System.Windows.Forms.RadioButton
    Friend WithEvents ChannelComboBox As System.Windows.Forms.ComboBox
    Friend WithEvents ChannelLabel As System.Windows.Forms.Label
    Friend WithEvents PassFailureStatusStrip As System.Windows.Forms.StatusStrip
    Friend WithEvents PassFailStatusLabel As System.Windows.Forms.ToolStripStatusLabel
    Friend WithEvents GPIOH4InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH4OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH5InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH5OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH6InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH6OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH7InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH7OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH0InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH1InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH2InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH3InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH4InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH5InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH6InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH7InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents PassFailResultsStatusLabel As System.Windows.Forms.ToolStripStatusLabel
    Friend WithEvents GPIOL1InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOL1OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOL1InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOL2InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOL2OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOL2InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOL3InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOL3OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOL3InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents MultipleThreadingCheckBox As System.Windows.Forms.CheckBox

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents TestButton As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(MainForm))
        Me.TestButton = New System.Windows.Forms.Button
        Me.DLLVersionLabel = New System.Windows.Forms.Label
        Me.GPIOL1To3GPIOH0To7OnlyCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH0InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH0OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH1InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH1OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH2InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH2OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH3InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH3OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.DeviceNameLabel = New System.Windows.Forms.Label
        Me.HiSpeedDeviceTypeGroupBox = New System.Windows.Forms.GroupBox
        Me.FT4232HRadioButton = New System.Windows.Forms.RadioButton
        Me.FT2232HRadioButton = New System.Windows.Forms.RadioButton
        Me.ChannelComboBox = New System.Windows.Forms.ComboBox
        Me.ChannelLabel = New System.Windows.Forms.Label
        Me.PassFailureStatusStrip = New System.Windows.Forms.StatusStrip
        Me.PassFailStatusLabel = New System.Windows.Forms.ToolStripStatusLabel
        Me.PassFailResultsStatusLabel = New System.Windows.Forms.ToolStripStatusLabel
        Me.GPIOH4InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH4OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH5InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH5OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH6InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH6OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH7InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH7OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH0InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH1InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH2InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH3InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH4InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH5InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH6InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH7InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOL1InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOL1OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOL1InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOL2InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOL2OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOL2InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOL3InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOL3OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOL3InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.MultipleThreadingCheckBox = New System.Windows.Forms.CheckBox
        Me.HiSpeedDeviceTypeGroupBox.SuspendLayout()
        Me.PassFailureStatusStrip.SuspendLayout()
        Me.SuspendLayout()
        '
        'TestButton
        '
        Me.TestButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TestButton.Location = New System.Drawing.Point(772, 495)
        Me.TestButton.Name = "TestButton"
        Me.TestButton.Size = New System.Drawing.Size(72, 24)
        Me.TestButton.TabIndex = 0
        Me.TestButton.Text = "Test"
        '
        'DLLVersionLabel
        '
        Me.DLLVersionLabel.AutoSize = True
        Me.DLLVersionLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DLLVersionLabel.Location = New System.Drawing.Point(28, 127)
        Me.DLLVersionLabel.Name = "DLLVersionLabel"
        Me.DLLVersionLabel.Size = New System.Drawing.Size(210, 13)
        Me.DLLVersionLabel.TabIndex = 1
        Me.DLLVersionLabel.Text = "FT2232/FT4232 I2C DLL Version = "
        '
        'GPIOL1To3GPIOH0To7OnlyCheckBox
        '
        Me.GPIOL1To3GPIOH0To7OnlyCheckBox.AutoSize = True
        Me.GPIOL1To3GPIOH0To7OnlyCheckBox.Location = New System.Drawing.Point(31, 310)
        Me.GPIOL1To3GPIOH0To7OnlyCheckBox.Name = "GPIOL1To3GPIOH0To7OnlyCheckBox"
        Me.GPIOL1To3GPIOH0To7OnlyCheckBox.Size = New System.Drawing.Size(224, 17)
        Me.GPIOL1To3GPIOH0To7OnlyCheckBox.TabIndex = 3
        Me.GPIOL1To3GPIOH0To7OnlyCheckBox.Text = "Test GPIOL (1 - 3) and GPIOH (0 - 7) Only"
        Me.GPIOL1To3GPIOH0To7OnlyCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH0InputOutputInitialStateCheckBox
        '
        Me.GPIOH0InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH0InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH0InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH0InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 177)
        Me.GPIOH0InputOutputInitialStateCheckBox.Name = "GPIOH0InputOutputInitialStateCheckBox"
        Me.GPIOH0InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH0InputOutputInitialStateCheckBox.TabIndex = 4
        Me.GPIOH0InputOutputInitialStateCheckBox.Text = "GPIOH0 Input Output(Checked) Initial State"
        Me.GPIOH0InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH0OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH0OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH0OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 191)
        Me.GPIOH0OutputLowHighInitialStateCheckBox.Name = "GPIOH0OutputLowHighInitialStateCheckBox"
        Me.GPIOH0OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH0OutputLowHighInitialStateCheckBox.TabIndex = 5
        Me.GPIOH0OutputLowHighInitialStateCheckBox.Text = "GPIOH0 Output Low High(Checked) Initial State"
        Me.GPIOH0OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH1InputOutputInitialStateCheckBox
        '
        Me.GPIOH1InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH1InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH1InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH1InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 214)
        Me.GPIOH1InputOutputInitialStateCheckBox.Name = "GPIOH1InputOutputInitialStateCheckBox"
        Me.GPIOH1InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH1InputOutputInitialStateCheckBox.TabIndex = 6
        Me.GPIOH1InputOutputInitialStateCheckBox.Text = "GPIOH1 Input Output(Checked) Initial State"
        Me.GPIOH1InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH1OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH1OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH1OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 228)
        Me.GPIOH1OutputLowHighInitialStateCheckBox.Name = "GPIOH1OutputLowHighInitialStateCheckBox"
        Me.GPIOH1OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH1OutputLowHighInitialStateCheckBox.TabIndex = 7
        Me.GPIOH1OutputLowHighInitialStateCheckBox.Text = "GPIOH1 Output Low High(Checked) Initial State"
        Me.GPIOH1OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH2InputOutputInitialStateCheckBox
        '
        Me.GPIOH2InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH2InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH2InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH2InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 251)
        Me.GPIOH2InputOutputInitialStateCheckBox.Name = "GPIOH2InputOutputInitialStateCheckBox"
        Me.GPIOH2InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH2InputOutputInitialStateCheckBox.TabIndex = 8
        Me.GPIOH2InputOutputInitialStateCheckBox.Text = "GPIOH2 Input Output(Checked) Initial State"
        Me.GPIOH2InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH2OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH2OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH2OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 264)
        Me.GPIOH2OutputLowHighInitialStateCheckBox.Name = "GPIOH2OutputLowHighInitialStateCheckBox"
        Me.GPIOH2OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH2OutputLowHighInitialStateCheckBox.TabIndex = 9
        Me.GPIOH2OutputLowHighInitialStateCheckBox.Text = "GPIOH2 Output Low High(Checked) Initial State"
        Me.GPIOH2OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH3InputOutputInitialStateCheckBox
        '
        Me.GPIOH3InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH3InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH3InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH3InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 287)
        Me.GPIOH3InputOutputInitialStateCheckBox.Name = "GPIOH3InputOutputInitialStateCheckBox"
        Me.GPIOH3InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH3InputOutputInitialStateCheckBox.TabIndex = 10
        Me.GPIOH3InputOutputInitialStateCheckBox.Text = "GPIOH3 Input Output(Checked) Initial State"
        Me.GPIOH3InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH3OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH3OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH3OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 301)
        Me.GPIOH3OutputLowHighInitialStateCheckBox.Name = "GPIOH3OutputLowHighInitialStateCheckBox"
        Me.GPIOH3OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH3OutputLowHighInitialStateCheckBox.TabIndex = 11
        Me.GPIOH3OutputLowHighInitialStateCheckBox.Text = "GPIOH3 Output Low High(Checked) Initial State"
        Me.GPIOH3OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'DeviceNameLabel
        '
        Me.DeviceNameLabel.AutoSize = True
        Me.DeviceNameLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DeviceNameLabel.Location = New System.Drawing.Point(28, 177)
        Me.DeviceNameLabel.Name = "DeviceNameLabel"
        Me.DeviceNameLabel.Size = New System.Drawing.Size(98, 13)
        Me.DeviceNameLabel.TabIndex = 12
        Me.DeviceNameLabel.Text = "Device Name = "
        '
        'HiSpeedDeviceTypeGroupBox
        '
        Me.HiSpeedDeviceTypeGroupBox.Controls.Add(Me.FT4232HRadioButton)
        Me.HiSpeedDeviceTypeGroupBox.Controls.Add(Me.FT2232HRadioButton)
        Me.HiSpeedDeviceTypeGroupBox.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.HiSpeedDeviceTypeGroupBox.Location = New System.Drawing.Point(31, 228)
        Me.HiSpeedDeviceTypeGroupBox.Name = "HiSpeedDeviceTypeGroupBox"
        Me.HiSpeedDeviceTypeGroupBox.Size = New System.Drawing.Size(178, 53)
        Me.HiSpeedDeviceTypeGroupBox.TabIndex = 13
        Me.HiSpeedDeviceTypeGroupBox.TabStop = False
        Me.HiSpeedDeviceTypeGroupBox.Text = "Hi Speed Device Type"
        '
        'FT4232HRadioButton
        '
        Me.FT4232HRadioButton.AutoSize = True
        Me.FT4232HRadioButton.Enabled = False
        Me.FT4232HRadioButton.Location = New System.Drawing.Point(91, 20)
        Me.FT4232HRadioButton.Name = "FT4232HRadioButton"
        Me.FT4232HRadioButton.Size = New System.Drawing.Size(77, 17)
        Me.FT4232HRadioButton.TabIndex = 1
        Me.FT4232HRadioButton.TabStop = True
        Me.FT4232HRadioButton.Text = "FT4232H"
        Me.FT4232HRadioButton.UseVisualStyleBackColor = True
        '
        'FT2232HRadioButton
        '
        Me.FT2232HRadioButton.AutoSize = True
        Me.FT2232HRadioButton.Enabled = False
        Me.FT2232HRadioButton.Location = New System.Drawing.Point(7, 20)
        Me.FT2232HRadioButton.Name = "FT2232HRadioButton"
        Me.FT2232HRadioButton.Size = New System.Drawing.Size(77, 17)
        Me.FT2232HRadioButton.TabIndex = 0
        Me.FT2232HRadioButton.TabStop = True
        Me.FT2232HRadioButton.Text = "FT2232H"
        Me.FT2232HRadioButton.UseVisualStyleBackColor = True
        '
        'ChannelComboBox
        '
        Me.ChannelComboBox.FormattingEnabled = True
        Me.ChannelComboBox.Location = New System.Drawing.Point(87, 25)
        Me.ChannelComboBox.Name = "ChannelComboBox"
        Me.ChannelComboBox.Size = New System.Drawing.Size(48, 21)
        Me.ChannelComboBox.TabIndex = 14
        '
        'ChannelLabel
        '
        Me.ChannelLabel.AutoSize = True
        Me.ChannelLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ChannelLabel.Location = New System.Drawing.Point(28, 28)
        Me.ChannelLabel.Name = "ChannelLabel"
        Me.ChannelLabel.Size = New System.Drawing.Size(53, 13)
        Me.ChannelLabel.TabIndex = 15
        Me.ChannelLabel.Text = "Channel"
        '
        'PassFailureStatusStrip
        '
        Me.PassFailureStatusStrip.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.PassFailStatusLabel, Me.PassFailResultsStatusLabel})
        Me.PassFailureStatusStrip.Location = New System.Drawing.Point(0, 542)
        Me.PassFailureStatusStrip.Name = "PassFailureStatusStrip"
        Me.PassFailureStatusStrip.Size = New System.Drawing.Size(884, 22)
        Me.PassFailureStatusStrip.TabIndex = 16
        '
        'PassFailStatusLabel
        '
        Me.PassFailStatusLabel.BorderSides = System.Windows.Forms.ToolStripStatusLabelBorderSides.Right
        Me.PassFailStatusLabel.Font = New System.Drawing.Font("Tahoma", 8.25!, System.Drawing.FontStyle.Bold)
        Me.PassFailStatusLabel.Name = "PassFailStatusLabel"
        Me.PassFailStatusLabel.Size = New System.Drawing.Size(121, 17)
        Me.PassFailStatusLabel.Text = "Pass/Failure Status"
        '
        'PassFailResultsStatusLabel
        '
        Me.PassFailResultsStatusLabel.Name = "PassFailResultsStatusLabel"
        Me.PassFailResultsStatusLabel.Size = New System.Drawing.Size(0, 17)
        '
        'GPIOH4InputOutputInitialStateCheckBox
        '
        Me.GPIOH4InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH4InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH4InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH4InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 324)
        Me.GPIOH4InputOutputInitialStateCheckBox.Name = "GPIOH4InputOutputInitialStateCheckBox"
        Me.GPIOH4InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH4InputOutputInitialStateCheckBox.TabIndex = 17
        Me.GPIOH4InputOutputInitialStateCheckBox.Text = "GPIOH4 Input Output(Checked) Initial State"
        Me.GPIOH4InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH4OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH4OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH4OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 337)
        Me.GPIOH4OutputLowHighInitialStateCheckBox.Name = "GPIOH4OutputLowHighInitialStateCheckBox"
        Me.GPIOH4OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH4OutputLowHighInitialStateCheckBox.TabIndex = 18
        Me.GPIOH4OutputLowHighInitialStateCheckBox.Text = "GPIOH4 Output Low High(Checked) Initial State"
        Me.GPIOH4OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH5InputOutputInitialStateCheckBox
        '
        Me.GPIOH5InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH5InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH5InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH5InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 360)
        Me.GPIOH5InputOutputInitialStateCheckBox.Name = "GPIOH5InputOutputInitialStateCheckBox"
        Me.GPIOH5InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH5InputOutputInitialStateCheckBox.TabIndex = 19
        Me.GPIOH5InputOutputInitialStateCheckBox.Text = "GPIOH5 Input Output(Checked) Initial State"
        Me.GPIOH5InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH5OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH5OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH5OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 373)
        Me.GPIOH5OutputLowHighInitialStateCheckBox.Name = "GPIOH5OutputLowHighInitialStateCheckBox"
        Me.GPIOH5OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH5OutputLowHighInitialStateCheckBox.TabIndex = 20
        Me.GPIOH5OutputLowHighInitialStateCheckBox.Text = "GPIOH5 Output Low High(Checked) Initial State"
        Me.GPIOH5OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH6InputOutputInitialStateCheckBox
        '
        Me.GPIOH6InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH6InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH6InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH6InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 396)
        Me.GPIOH6InputOutputInitialStateCheckBox.Name = "GPIOH6InputOutputInitialStateCheckBox"
        Me.GPIOH6InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH6InputOutputInitialStateCheckBox.TabIndex = 21
        Me.GPIOH6InputOutputInitialStateCheckBox.Text = "GPIOH6 Input Output(Checked) Initial State"
        Me.GPIOH6InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH6OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH6OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH6OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 410)
        Me.GPIOH6OutputLowHighInitialStateCheckBox.Name = "GPIOH6OutputLowHighInitialStateCheckBox"
        Me.GPIOH6OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH6OutputLowHighInitialStateCheckBox.TabIndex = 22
        Me.GPIOH6OutputLowHighInitialStateCheckBox.Text = "GPIOH6 Output Low High(Checked) Initial State"
        Me.GPIOH6OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH7InputOutputInitialStateCheckBox
        '
        Me.GPIOH7InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH7InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH7InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH7InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 433)
        Me.GPIOH7InputOutputInitialStateCheckBox.Name = "GPIOH7InputOutputInitialStateCheckBox"
        Me.GPIOH7InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH7InputOutputInitialStateCheckBox.TabIndex = 23
        Me.GPIOH7InputOutputInitialStateCheckBox.Text = "GPIOH7 Input Output(Checked) Initial State"
        Me.GPIOH7InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH7OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH7OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH7OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 447)
        Me.GPIOH7OutputLowHighInitialStateCheckBox.Name = "GPIOH7OutputLowHighInitialStateCheckBox"
        Me.GPIOH7OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH7OutputLowHighInitialStateCheckBox.TabIndex = 24
        Me.GPIOH7OutputLowHighInitialStateCheckBox.Text = "GPIOH7 Output Low High(Checked) Initial State"
        Me.GPIOH7OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH0InputLowHighReadStateCheckBox
        '
        Me.GPIOH0InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH0InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 191)
        Me.GPIOH0InputLowHighReadStateCheckBox.Name = "GPIOH0InputLowHighReadStateCheckBox"
        Me.GPIOH0InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH0InputLowHighReadStateCheckBox.TabIndex = 25
        Me.GPIOH0InputLowHighReadStateCheckBox.Text = "GPIOH0 Input Low High(Checked) Read State"
        Me.GPIOH0InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH1InputLowHighReadStateCheckBox
        '
        Me.GPIOH1InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH1InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 228)
        Me.GPIOH1InputLowHighReadStateCheckBox.Name = "GPIOH1InputLowHighReadStateCheckBox"
        Me.GPIOH1InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH1InputLowHighReadStateCheckBox.TabIndex = 26
        Me.GPIOH1InputLowHighReadStateCheckBox.Text = "GPIOH1 Input Low High(Checked) Read State"
        Me.GPIOH1InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH2InputLowHighReadStateCheckBox
        '
        Me.GPIOH2InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH2InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 264)
        Me.GPIOH2InputLowHighReadStateCheckBox.Name = "GPIOH2InputLowHighReadStateCheckBox"
        Me.GPIOH2InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH2InputLowHighReadStateCheckBox.TabIndex = 27
        Me.GPIOH2InputLowHighReadStateCheckBox.Text = "GPIOH2 Input Low High(Checked) Read State"
        Me.GPIOH2InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH3InputLowHighReadStateCheckBox
        '
        Me.GPIOH3InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH3InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 301)
        Me.GPIOH3InputLowHighReadStateCheckBox.Name = "GPIOH3InputLowHighReadStateCheckBox"
        Me.GPIOH3InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH3InputLowHighReadStateCheckBox.TabIndex = 28
        Me.GPIOH3InputLowHighReadStateCheckBox.Text = "GPIOH3 Input Low High(Checked) Read State"
        Me.GPIOH3InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH4InputLowHighReadStateCheckBox
        '
        Me.GPIOH4InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH4InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 337)
        Me.GPIOH4InputLowHighReadStateCheckBox.Name = "GPIOH4InputLowHighReadStateCheckBox"
        Me.GPIOH4InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH4InputLowHighReadStateCheckBox.TabIndex = 29
        Me.GPIOH4InputLowHighReadStateCheckBox.Text = "GPIOH4 Input Low High(Checked) Read State"
        Me.GPIOH4InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH5InputLowHighReadStateCheckBox
        '
        Me.GPIOH5InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH5InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 373)
        Me.GPIOH5InputLowHighReadStateCheckBox.Name = "GPIOH5InputLowHighReadStateCheckBox"
        Me.GPIOH5InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH5InputLowHighReadStateCheckBox.TabIndex = 30
        Me.GPIOH5InputLowHighReadStateCheckBox.Text = "GPIOH5 Input Low High(Checked) Read State"
        Me.GPIOH5InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH6InputLowHighReadStateCheckBox
        '
        Me.GPIOH6InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH6InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 410)
        Me.GPIOH6InputLowHighReadStateCheckBox.Name = "GPIOH6InputLowHighReadStateCheckBox"
        Me.GPIOH6InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH6InputLowHighReadStateCheckBox.TabIndex = 31
        Me.GPIOH6InputLowHighReadStateCheckBox.Text = "GPIOH6 Input Low High(Checked) Read State"
        Me.GPIOH6InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH7InputLowHighReadStateCheckBox
        '
        Me.GPIOH7InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH7InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 447)
        Me.GPIOH7InputLowHighReadStateCheckBox.Name = "GPIOH7InputLowHighReadStateCheckBox"
        Me.GPIOH7InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH7InputLowHighReadStateCheckBox.TabIndex = 32
        Me.GPIOH7InputLowHighReadStateCheckBox.Text = "GPIOH7 Input Low High(Checked) Read State"
        Me.GPIOH7InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOL1InputOutputInitialStateCheckBox
        '
        Me.GPIOL1InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOL1InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOL1InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOL1InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 29)
        Me.GPIOL1InputOutputInitialStateCheckBox.Name = "GPIOL1InputOutputInitialStateCheckBox"
        Me.GPIOL1InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(230, 17)
        Me.GPIOL1InputOutputInitialStateCheckBox.TabIndex = 33
        Me.GPIOL1InputOutputInitialStateCheckBox.Text = "GPIOL1 Input Output(Checked) Initial State"
        Me.GPIOL1InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOL1OutputLowHighInitialStateCheckBox
        '
        Me.GPIOL1OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOL1OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 45)
        Me.GPIOL1OutputLowHighInitialStateCheckBox.Name = "GPIOL1OutputLowHighInitialStateCheckBox"
        Me.GPIOL1OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(251, 17)
        Me.GPIOL1OutputLowHighInitialStateCheckBox.TabIndex = 34
        Me.GPIOL1OutputLowHighInitialStateCheckBox.Text = "GPIOL1 Output Low High(Checked) Initial State"
        Me.GPIOL1OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOL1InputLowHighReadStateCheckBox
        '
        Me.GPIOL1InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOL1InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 45)
        Me.GPIOL1InputLowHighReadStateCheckBox.Name = "GPIOL1InputLowHighReadStateCheckBox"
        Me.GPIOL1InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(245, 17)
        Me.GPIOL1InputLowHighReadStateCheckBox.TabIndex = 35
        Me.GPIOL1InputLowHighReadStateCheckBox.Text = "GPIOL1 Input Low High(Checked) Read State"
        Me.GPIOL1InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOL2InputOutputInitialStateCheckBox
        '
        Me.GPIOL2InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOL2InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOL2InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOL2InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 64)
        Me.GPIOL2InputOutputInitialStateCheckBox.Name = "GPIOL2InputOutputInitialStateCheckBox"
        Me.GPIOL2InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(230, 17)
        Me.GPIOL2InputOutputInitialStateCheckBox.TabIndex = 36
        Me.GPIOL2InputOutputInitialStateCheckBox.Text = "GPIOL2 Input Output(Checked) Initial State"
        Me.GPIOL2InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOL2OutputLowHighInitialStateCheckBox
        '
        Me.GPIOL2OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOL2OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 78)
        Me.GPIOL2OutputLowHighInitialStateCheckBox.Name = "GPIOL2OutputLowHighInitialStateCheckBox"
        Me.GPIOL2OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(251, 17)
        Me.GPIOL2OutputLowHighInitialStateCheckBox.TabIndex = 37
        Me.GPIOL2OutputLowHighInitialStateCheckBox.Text = "GPIOL2 Output Low High(Checked) Initial State"
        Me.GPIOL2OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOL2InputLowHighReadStateCheckBox
        '
        Me.GPIOL2InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOL2InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 78)
        Me.GPIOL2InputLowHighReadStateCheckBox.Name = "GPIOL2InputLowHighReadStateCheckBox"
        Me.GPIOL2InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(245, 17)
        Me.GPIOL2InputLowHighReadStateCheckBox.TabIndex = 38
        Me.GPIOL2InputLowHighReadStateCheckBox.Text = "GPIOL2 Input Low High(Checked) Read State"
        Me.GPIOL2InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOL3InputOutputInitialStateCheckBox
        '
        Me.GPIOL3InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOL3InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOL3InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOL3InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(306, 97)
        Me.GPIOL3InputOutputInitialStateCheckBox.Name = "GPIOL3InputOutputInitialStateCheckBox"
        Me.GPIOL3InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(230, 17)
        Me.GPIOL3InputOutputInitialStateCheckBox.TabIndex = 39
        Me.GPIOL3InputOutputInitialStateCheckBox.Text = "GPIOL3 Input Output(Checked) Initial State"
        Me.GPIOL3InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOL3OutputLowHighInitialStateCheckBox
        '
        Me.GPIOL3OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOL3OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(324, 112)
        Me.GPIOL3OutputLowHighInitialStateCheckBox.Name = "GPIOL3OutputLowHighInitialStateCheckBox"
        Me.GPIOL3OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(251, 17)
        Me.GPIOL3OutputLowHighInitialStateCheckBox.TabIndex = 40
        Me.GPIOL3OutputLowHighInitialStateCheckBox.Text = "GPIOL3 Output Low High(Checked) Initial State"
        Me.GPIOL3OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOL3InputLowHighReadStateCheckBox
        '
        Me.GPIOL3InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOL3InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(597, 112)
        Me.GPIOL3InputLowHighReadStateCheckBox.Name = "GPIOL3InputLowHighReadStateCheckBox"
        Me.GPIOL3InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(245, 17)
        Me.GPIOL3InputLowHighReadStateCheckBox.TabIndex = 41
        Me.GPIOL3InputLowHighReadStateCheckBox.Text = "GPIOL3 Input Low High(Checked) Read State"
        Me.GPIOL3InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'MultipleThreadingCheckBox
        '
        Me.MultipleThreadingCheckBox.AutoSize = True
        Me.MultipleThreadingCheckBox.Location = New System.Drawing.Point(31, 78)
        Me.MultipleThreadingCheckBox.Name = "MultipleThreadingCheckBox"
        Me.MultipleThreadingCheckBox.Size = New System.Drawing.Size(176, 17)
        Me.MultipleThreadingCheckBox.TabIndex = 42
        Me.MultipleThreadingCheckBox.Text = "Perform Multiple Threading Test"
        Me.MultipleThreadingCheckBox.UseVisualStyleBackColor = True
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(884, 564)
        Me.Controls.Add(Me.MultipleThreadingCheckBox)
        Me.Controls.Add(Me.GPIOL3InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOL3OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOL3InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOL2InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOL2OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOL2InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOL1InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOL1OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOL1InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH7InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH6InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH5InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH4InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH3InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH2InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH1InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH0InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH7OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH7InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH6OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH6InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH5OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH5InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH4OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH4InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.PassFailureStatusStrip)
        Me.Controls.Add(Me.ChannelLabel)
        Me.Controls.Add(Me.ChannelComboBox)
        Me.Controls.Add(Me.HiSpeedDeviceTypeGroupBox)
        Me.Controls.Add(Me.DeviceNameLabel)
        Me.Controls.Add(Me.GPIOH3OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH3InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH2OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH2InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH1OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH1InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH0OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH0InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOL1To3GPIOH0To7OnlyCheckBox)
        Me.Controls.Add(Me.DLLVersionLabel)
        Me.Controls.Add(Me.TestButton)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "MainForm"
        Me.HiSpeedDeviceTypeGroupBox.ResumeLayout(False)
        Me.HiSpeedDeviceTypeGroupBox.PerformLayout()
        Me.PassFailureStatusStrip.ResumeLayout(False)
        Me.PassFailureStatusStrip.PerformLayout()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Public Structure FTC_PAGE_WRITE_DATA
        Public NumPages As Integer
        Public NumBytesPerPage As Integer
    End Structure
    Public Structure FTC_INPUT_OUTPUT_PINS
        Public bPin1InputOutputState As Boolean
        Public bPin1LowHighState As Boolean
        Public bPin2InputOutputState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3InputOutputState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4InputOutputState As Boolean
        Public bPin4LowHighState As Boolean
    End Structure
    Public Structure FTH_INPUT_OUTPUT_PINS
        Public bPin1InputOutputState As Boolean
        Public bPin1LowHighState As Boolean
        Public bPin2InputOutputState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3InputOutputState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4InputOutputState As Boolean
        Public bPin4LowHighState As Boolean
        Public bPin5InputOutputState As Boolean
        Public bPin5LowHighState As Boolean
        Public bPin6InputOutputState As Boolean
        Public bPin6LowHighState As Boolean
        Public bPin7InputOutputState As Boolean
        Public bPin7LowHighState As Boolean
        Public bPin8InputOutputState As Boolean
        Public bPin8LowHighState As Boolean
    End Structure
    Public Structure FTC_LOW_HIGH_PINS
        Public bPin1LowHighState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4LowHighState As Boolean
    End Structure
    Public Structure FTH_LOW_HIGH_PINS
        Public bPin1LowHighState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4LowHighState As Boolean
        Public bPin5LowHighState As Boolean
        Public bPin6LowHighState As Boolean
        Public bPin7LowHighState As Boolean
        Public bPin8LowHighState As Boolean
    End Structure
    Public Structure FTC_CLOSE_FINAL_STATE_PINS
        Public bTCKPinState As Boolean
        Public bTCKPinActiveState As Boolean
        Public bTDIPinState As Boolean
        Public bTDIPinActiveState As Boolean
        Public bTMSPinState As Boolean
        Public bTMSPinActiveState As Boolean
    End Structure

    Private Declare Function I2C_GetNumHiSpeedDevices Lib "ftci2c" (ByRef NumHiSpeedDevices As Long) As Integer
    Private Declare Function I2C_GetHiSpeedDeviceNameLocIDChannel Lib "ftci2c" (ByVal DeviceNameIndex As Integer, ByVal DeviceName As String, ByVal DeviceNameBufferSize As Integer, ByRef lpLocationID As Long, ByVal Channel As String, ByVal ChannelBufferSize As Integer, ByRef lpHiSpeedDeviceType As Long) As Integer
    Private Declare Function I2C_OpenHiSpeedDevice Lib "ftci2c" (ByVal DeviceName As String, ByVal LocationID As Integer, ByVal Channel As String, ByRef ftHandle As Long) As Integer
    Private Declare Function I2C_Close Lib "ftci2c" (ByVal ftHandle As Integer) As Integer
    Private Declare Function I2C_CloseDevice Lib "ftci2c" (ByVal ftHandle As Integer, ByRef pCloseFinalStatePinsData As FTC_CLOSE_FINAL_STATE_PINS) As Integer
    Private Declare Function I2C_GetHiSpeedDeviceType Lib "ftci2c" (ByVal ftHandle As Integer, ByRef lpHiSpeedDeviceType As Long) As Integer
    Private Declare Function I2C_InitDevice Lib "ftci2c" (ByVal ftHandle As Integer, ByVal ClockDivisor As Integer) As Integer
    Private Declare Function I2C_TurnOnDivideByFiveClockingHiSpeedDevice Lib "ftci2c" (ByVal ftHandle As Integer) As Integer
    Private Declare Function I2C_TurnOffDivideByFiveClockingHiSpeedDevice Lib "ftci2c" (ByVal ftHandle As Integer) As Integer
    Private Declare Function I2C_TurnOnThreePhaseDataClockingHiSpeedDevice Lib "ftci2c" (ByVal ftHandle As Integer) As Integer
    Private Declare Function I2C_TurnOffThreePhaseDataClockingHiSpeedDevice Lib "ftci2c" (ByVal ftHandle As Integer) As Integer
    Private Declare Function I2C_SetDeviceLatencyTimer Lib "ftci2c" (ByVal ftHandle As Integer, ByVal TimerValue As Byte) As Integer
    Private Declare Function I2C_GetDeviceLatencyTimer Lib "ftci2c" (ByVal ftHandle As Integer, ByRef lpTimerValue As Byte) As Integer
    Private Declare Function I2C_GetHiSpeedDeviceClock Lib "ftci2c" (ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function I2C_GetClock Lib "ftci2c" (ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function I2C_SetClock Lib "ftci2c" (ByVal ftHandle As Integer, ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function I2C_SetLoopback Lib "ftci2c" (ByVal ftHandle As Integer, ByVal bLoopbackState As Boolean) As Integer
    Private Declare Function I2C_SetMode Lib "ftci2c" (ByVal ftHandle As Integer, ByVal CommsMode As Integer) As Integer
    Private Declare Function I2C_SetGPIOs Lib "ftci2c" (ByVal ftHandle As Integer, ByRef pHighInputOutputPinsData As FTC_INPUT_OUTPUT_PINS) As Integer
    Private Declare Function I2C_SetHiSpeedDeviceGPIOs Lib "ftci2c" (ByVal ftHandle As Integer, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighInputOutputPinsData As FTH_INPUT_OUTPUT_PINS) As Integer
    Private Declare Function I2C_GetGPIOs Lib "ftci2c" (ByVal ftHandle As Integer, ByRef pHighPinsInputData As FTC_LOW_HIGH_PINS) As Integer
    Private Declare Function I2C_GetHiSpeedDeviceGPIOs Lib "ftci2c" (ByVal ftHandle As Integer, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowPinsInputData As FTC_LOW_HIGH_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighPinsInputData As FTH_LOW_HIGH_PINS) As Integer
    Private Declare Function I2C_Write Lib "ftci2c" (ByVal ftHandle As Integer, ByVal WriteControlBuffer() As Byte, ByVal NumControlBytesToWrite As Integer, ByVal bControlAcknowledge As Boolean, ByVal NumControlAckTimeoutmSecs As Integer, ByVal bStopCondition As Boolean, ByVal DataWriteTypes As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumDataBytesToWrite As Integer, ByVal bDataAcknowledge As Boolean, ByVal NumDataAckTimeoutmSecs As Integer, ByRef pPageWriteData As FTC_PAGE_WRITE_DATA) As Integer
    Private Declare Function I2C_Read Lib "ftci2c" (ByVal ftHandle As Integer, ByVal WriteControlBuffer() As Byte, ByVal NumControlBytesToWrite As Integer, ByVal bControlAcknowledge As Boolean, ByVal NumControlAckTimeoutmSecs As Integer, ByVal DataReadTypes As Integer, ByVal ReadDataBuffer() As Byte, ByVal NumDataBytesToRead As Integer) As Integer
    'Private Declare Function I2C_GetDllVersion Lib "ftci2c" (ByVal DllVersion As String, ByVal BufferSize As Integer) As Integer
    Private Declare Function GetDllVersion Lib "ftci2c" Alias "I2C_GetDllVersion" (ByVal DllVersion As String, ByVal BufferSize As Integer) As Integer
    Private Declare Function I2C_GetErrorCodeString Lib "ftci2c" (ByVal Language As String, ByVal StatusCode As Integer, ByVal ErrorMessage As String, ByVal BufferSize As Integer) As Integer

    Private Declare Function Sleep Lib "Kernel32" (ByVal Milliseconds As Integer) As Long

    Private Const FTC_SUCCESS = 0
    Private Const FTC_DEVICE_IN_USE = 27

    Private Const NO_WRITE_TYPE = 0
    Private Const BYTE_WRITE_TYPE = 1
    Private Const PAGE_WRITE_TYPE = 2

    Private Const BYTE_READ_TYPE = 1
    Private Const PAGE_READ_TYPE = 2

    Private Const STANDARD_MODE = 1
    Private Const FAST_MODE = 2
    Private Const STRETCH_DATA_MODE = 4

    Private Const WRITE_CONTROL_BUFFER_SIZE = 256
    Private Const WRITE_DATA_BUFFER_SIZE = 65536
    Private Const READ_DATA_BUFFER_SIZE = 65536

    Private Const MAX_NUM_DEVICE_NAME_CHARS = 100
    Private Const MAX_NUM_CHANNEL_CHARS = 5

    Private Const MAX_NUM_DLL_VERSION_CHARS = 10

    Private Const MAX_NUM_ERROR_MESSAGE_CHARS = 100

    Private Const App_Title = "FT2232/FT4232 Hi-Speed I2C Device Visual Basic .NET Test Application"

    Private Const Dll_Version_Label = "FT2232/FT4232 I2C DLL Version = "

    Private Const Device_Name_Label = "Device Name = "

    Private Enum hiSpeedDeviceTypes
        FT2232H_Device_Type = 1
        FT4232H_Device_Type = 2
    End Enum

    Private Const Pass_Fail_Label = "Pass/Failure = "

    Private Const MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES = 512

    Private Const NUM_M24C64_PAGES = 1
    Private Const NUM_M24C64_BYTES_PER_PAGE = 32

    Private Const MAX_I2C_24LC16B_CHIP_SIZE_IN_BYTES = 256

    Private Const NUM_24LC16B_PAGES = 8
    Private Const NUM_24LC16B_BYTES_PER_PAGE = 256

    ' To communicate with the M24C64(8192 byte) EEPROM, the maximum frequency the clock can be set is 375KHz 
    Private Const MAX_FREQ_M24C64_CLOCK_DIVISOR = 79    ' equivalent to 375KHz

    Private ftHandle As Integer = 0

    Private Shared Function ConvertDLLStringToVBString(ByRef DLLString As String) As String
        Dim VBString As String
        Dim iCharCntr As Integer = 0
        Dim CharArray() As Char

        While (DLLString.Chars(iCharCntr) <> vbNullChar)
            iCharCntr = iCharCntr + 1
        End While

        CharArray = New Char((iCharCntr - 1)) {}

        iCharCntr = 0
        While (DLLString.Chars(iCharCntr) <> vbNullChar)
            CharArray(iCharCntr) = DLLString.Chars(iCharCntr)
            iCharCntr = iCharCntr + 1
        End While

        VBString = New String(CharArray)

        Return VBString
    End Function

    Private Shared Function TestHiSpeedDeviceClock(ByVal ftHandle As Integer) As Integer
        Dim ftStatus As Integer = FTC_SUCCESS
        Dim ClockFrequencyHz As Long = 0

        ftStatus = I2C_GetHiSpeedDeviceClock(0, ClockFrequencyHz)

        If (ftStatus = FTC_SUCCESS) Then
            ftStatus = I2C_TurnOnDivideByFiveClockingHiSpeedDevice(ftHandle)

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = I2C_GetHiSpeedDeviceClock(0, ClockFrequencyHz)

                ftStatus = I2C_SetClock(ftHandle, MAX_FREQ_M24C64_CLOCK_DIVISOR, ClockFrequencyHz)

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_TurnOffDivideByFiveClockingHiSpeedDevice(ftHandle)

                    ftStatus = I2C_SetClock(ftHandle, MAX_FREQ_M24C64_CLOCK_DIVISOR, ClockFrequencyHz)
                End If
            End If
        End If

        Return ftStatus
    End Function

    Private Shared Sub ThreadProc()
        Dim ftStatus As Integer = FTC_SUCCESS
        Dim ftHandleThread As Integer = 0
        Dim NumHiSpeedDevices As Long = 0
        Dim HiSpeedDeviceName As String = New String(ChrW(0), MAX_NUM_DEVICE_NAME_CHARS)
        Dim HiSpeedDeviceChannel As String = New String(ChrW(0), MAX_NUM_CHANNEL_CHARS)
        Dim LocationID As Long = 0
        Dim HiSpeedDeviceType As Long = 0
        Dim HSDN As String
        Dim HSCH As String
        Dim HiSpeedDeviceIndex As Long = 0
        Dim TimerValue As Byte = 0
        Dim bLoopbackState As Boolean = False
        Dim LowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS = New FTC_INPUT_OUTPUT_PINS
        Dim HighInputOutputPinsData As FTH_INPUT_OUTPUT_PINS = New FTH_INPUT_OUTPUT_PINS
        Dim LowPinsInputData As FTC_LOW_HIGH_PINS = New FTC_LOW_HIGH_PINS
        Dim HighPinsInputData As FTH_LOW_HIGH_PINS = New FTH_LOW_HIGH_PINS
        Dim WriteDataByteAddress As Integer
        Dim WriteControlBuffer() As Byte = New Byte((WRITE_CONTROL_BUFFER_SIZE - 1)) {}
        Dim WriteDataBuffer() As Byte = New Byte((WRITE_DATA_BUFFER_SIZE - 1)) {}
        Dim PageWriteData As FTC_PAGE_WRITE_DATA
        Dim DataWriteType As Integer
        Dim DataByte As Byte = 0
        Dim NumDataBytesToWrite As Integer = 0
        Dim WriteDataBufferIndex As Integer = 0
        Dim ReadDataBuffer() As Byte = New Byte((READ_DATA_BUFFER_SIZE - 1)) {}
        Dim ReadData() As Byte = New Byte((READ_DATA_BUFFER_SIZE - 1)) {}
        Dim ReadDataIndex As Integer = 0
        Dim ReadDataByteAddress As Integer = 0
        Dim DataReadType As Integer = 0
        Dim NumDataBytesToRead As Long = 0
        Dim MsgBoxKeyPressed As Integer = 0
        Dim DataByteWritten As Byte = 0
        Dim CharCntr As Integer = 0
        Dim iLoopCntr As Integer = 0
        Dim mismatchMsg As String = vbNullString
        Dim style As MsgBoxStyle = MsgBoxStyle.OkCancel
        Dim response As MsgBoxResult = MsgBoxResult.Ok

        Dim StatusErrorMessage As String = New String(ChrW(0), MAX_NUM_ERROR_MESSAGE_CHARS)
        Dim ErrorMessage As String

        'Console.WriteLine("Second thread started.")

        ftStatus = I2C_GetNumHiSpeedDevices(NumHiSpeedDevices)

        'Console.WriteLine("Second thread get number of devices.")
        'Thread.Sleep(0)

        If ((ftStatus = FTC_SUCCESS) And (NumHiSpeedDevices > 0)) Then
            Do
                ftStatus = I2C_GetHiSpeedDeviceNameLocIDChannel(HiSpeedDeviceIndex, HiSpeedDeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID, HiSpeedDeviceChannel, MAX_NUM_CHANNEL_CHARS, HiSpeedDeviceType)

                If (ftStatus = FTC_SUCCESS) Then
                    HSCH = New String(ConvertDLLStringToVBString(HiSpeedDeviceChannel))
                End If

                HiSpeedDeviceIndex = HiSpeedDeviceIndex + 1
            Loop While ((ftStatus = FTC_SUCCESS) And (HiSpeedDeviceIndex < NumHiSpeedDevices) And ((HSCH <> vbNullString) And (HSCH <> "B")))

            If (ftStatus = FTC_SUCCESS) Then
                If ((HSCH <> vbNullString) And (HSCH <> "B")) Then
                    ftStatus = FTC_DEVICE_IN_USE
                End If
            End If

            If (ftStatus = FTC_SUCCESS) Then
                HSDN = New String(ConvertDLLStringToVBString(HiSpeedDeviceName))
                ftStatus = I2C_OpenHiSpeedDevice(HSDN, LocationID, HSCH, ftHandleThread)

                'Console.WriteLine("Second thread opened device.")

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_GetHiSpeedDeviceType(ftHandleThread, HiSpeedDeviceType)
                End If
            End If

            If ((ftHandleThread <> 0) And (ftStatus = FTC_SUCCESS)) Then
                ftStatus = I2C_InitDevice(ftHandleThread, MAX_FREQ_M24C64_CLOCK_DIVISOR)

                If (ftStatus = FTC_SUCCESS) Then
                    'ftStatus = I2C_TurnOnThreePhaseDataClockingHiSpeedDevice(ftHandleThread)

                    'ftStatus = I2C_TurnOffThreePhaseDataClockingHiSpeedDevice(ftHandleThread)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_GetDeviceLatencyTimer(ftHandleThread, TimerValue)

                    If (ftStatus = FTC_SUCCESS) Then
                        ftStatus = I2C_SetDeviceLatencyTimer(ftHandleThread, 50)

                        If (ftStatus = FTC_SUCCESS) Then
                            ftStatus = I2C_GetDeviceLatencyTimer(ftHandleThread, TimerValue)

                            ftStatus = I2C_SetDeviceLatencyTimer(ftHandleThread, 16)

                            ftStatus = I2C_GetDeviceLatencyTimer(ftHandleThread, TimerValue)
                        End If
                    End If
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = TestHiSpeedDeviceClock(ftHandleThread)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_SetLoopback(ftHandleThread, False)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_SetMode(ftHandleThread, FAST_MODE)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    LowInputOutputPinsData.bPin2InputOutputState = True 'Me.GPIOL1InputOutputInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin2LowHighState = True 'Me.GPIOL1OutputLowHighInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin3InputOutputState = True 'Me.GPIOL2InputOutputInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin3LowHighState = False 'Me.GPIOL2OutputLowHighInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin4InputOutputState = True 'Me.GPIOL3InputOutputInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin4LowHighState = True 'Me.GPIOL3OutputLowHighInitialStateCheckBox.Checked

                    If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                        ' Set the 8 general purpose higher input/output pins has to input or output
                        HighInputOutputPinsData.bPin1InputOutputState = True 'Me.GPIOH0InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin1LowHighState = True 'Me.GPIOH0OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin2InputOutputState = True 'Me.GPIOH1InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin2LowHighState = False 'Me.GPIOH1OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin3InputOutputState = True 'Me.GPIOH2InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin3LowHighState = True 'Me.GPIOH2OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin4InputOutputState = True 'Me.GPIOH3InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin4LowHighState = False 'Me.GPIOH3OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin5InputOutputState = True 'Me.GPIOH4InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin5LowHighState = True 'Me.GPIOH4OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin6InputOutputState = True 'Me.GPIOH5InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin6LowHighState = False 'Me.GPIOH5OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin7InputOutputState = True 'Me.GPIOH6InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin7LowHighState = True 'Me.GPIOH6OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin8InputOutputState = True 'Me.GPIOH7InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin8LowHighState = False 'Me.GPIOH7OutputLowHighInitialStateCheckBox.Checked

                        ftStatus = I2C_SetHiSpeedDeviceGPIOs(ftHandleThread, True, LowInputOutputPinsData, True, HighInputOutputPinsData)
                    Else
                        ftStatus = I2C_SetHiSpeedDeviceGPIOs(ftHandleThread, True, LowInputOutputPinsData, False, HighInputOutputPinsData)
                    End If

                    'Console.WriteLine("Second thread set GPIOs.")

                    If (ftStatus = FTC_SUCCESS) Then
                        Sleep(20)

                        If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                            ftStatus = I2C_GetHiSpeedDeviceGPIOs(ftHandleThread, True, LowPinsInputData, True, HighPinsInputData)
                        Else
                            ftStatus = I2C_GetHiSpeedDeviceGPIOs(ftHandleThread, True, LowPinsInputData, False, HighPinsInputData)
                        End If
                    End If

                    If (ftStatus = FTC_SUCCESS) Then
                        ' Modified device address to 1, to use the M24C64 EEPROM on the I2C Test Board With the 24C02(256 byte) EEPROM,
                        ' M24C64(8192 byte) EEPROM, DS1621(Digital Thermometer and Thermostat) and M41T81(Serial Real-Time Clock)
                        WriteControlBuffer(0) = &HA2 '1 0 1 0 A2 A1 A0 0 - device address 1

                        WriteDataBuffer(0) = &HFF  ' Erase address locations

                        WriteDataByteAddress = 0

                        Do
                            ' shift down by 8 bits
                            WriteControlBuffer(1) = ((WriteDataByteAddress >> 8) And &HFF)
                            WriteControlBuffer(2) = (WriteDataByteAddress And &HFF)

                            ftStatus = I2C_Write(ftHandleThread, WriteControlBuffer, 3, True, 20, True, BYTE_WRITE_TYPE, WriteDataBuffer, 1, True, 20, PageWriteData)

                            WriteDataByteAddress = WriteDataByteAddress + 1
                        Loop While ((WriteDataByteAddress < MAX_I2C_24LC16B_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))
                    End If

                    'Console.WriteLine("Second thread - erased EEPROM.")

                    If (ftStatus = FTC_SUCCESS) Then
                        ' Modified device address to 1, to use the M24C64 EEPROM on the I2C Test Board With the 24C02(256 byte) EEPROM,
                        ' M24C64(8192 byte) EEPROM, DS1621(Digital Thermometer and Thermostat) and M41T81(Serial Real-Time Clock)
                        WriteControlBuffer(0) = &HA2 '1 0 1 0 A2 A1 A0 0 - device address 1

                        WriteDataByteAddress = 0

                        DataWriteType = BYTE_WRITE_TYPE 'PAGE_WRITE_TYPE ';

                        DataByte = &H77

                        If (DataWriteType = BYTE_WRITE_TYPE) Then
                            WriteDataBuffer(0) = DataByte

                            NumDataBytesToWrite = 1
                        Else
                            WriteDataBuffer(0) = DataByte

                            PageWriteData.NumPages = NUM_24LC16B_PAGES
                            PageWriteData.NumBytesPerPage = NUM_24LC16B_BYTES_PER_PAGE

                            NumDataBytesToWrite = (NUM_24LC16B_PAGES * NUM_24LC16B_BYTES_PER_PAGE)

                            For WriteDataBufferIndex = 0 To (NumDataBytesToWrite - 1)
                                WriteDataBuffer(WriteDataBufferIndex) = DataByte
                            Next
                        End If

                        Do
                            ' performs an arithmetic right shift down by 8 bits
                            WriteControlBuffer(1) = ((WriteDataByteAddress >> 8) And &HFF)
                            WriteControlBuffer(2) = (WriteDataByteAddress And &HFF)

                            ftStatus = I2C_Write(ftHandleThread, WriteControlBuffer, 3, True, 20, True, DataWriteType, WriteDataBuffer, NumDataBytesToWrite, True, 20, PageWriteData)

                            If (DataWriteType = BYTE_WRITE_TYPE) Then
                                WriteDataByteAddress = WriteDataByteAddress + 1
                            Else
                                WriteDataByteAddress = WriteDataByteAddress + (NUM_24LC16B_PAGES * NUM_24LC16B_BYTES_PER_PAGE)
                            End If
                        Loop While ((WriteDataByteAddress < MAX_I2C_24LC16B_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                        'Console.WriteLine("Second thread - values written to EEPROM.")

                        If (ftStatus = FTC_SUCCESS) Then
                            Do
                                'WriteControlBuffer(0) = &HAF '1 0 1 0 A2 A1 A0 1 - device address 7
                                ' Modified device address to 1, to use the M24C64 EEPROM on the I2C Test Board With the 24C02(256 byte) EEPROM,
                                ' M24C64(8192 byte) EEPROM, DS1621(Digital Thermometer and Thermostat) and M41T81(Serial Real-Time Clock)
                                WriteControlBuffer(0) = &HA3 '1 0 1 0 A2 A1 A0 1 - device address 1

                                For ReadDataIndex = 0 To (MAX_I2C_24LC16B_CHIP_SIZE_IN_BYTES - 1)
                                    ReadData(ReadDataIndex) = 0
                                Next

                                ReadDataByteAddress = 0

                                DataReadType = BYTE_READ_TYPE 'BLOCK_READ_TYPE '

                                If (DataReadType = BYTE_READ_TYPE) Then
                                    NumDataBytesToRead = 1
                                Else
                                    NumDataBytesToRead = MAX_I2C_24LC16B_CHIP_SIZE_IN_BYTES
                                End If

                                Do
                                    ' shift down by 8 bits
                                    WriteControlBuffer(1) = ((ReadDataByteAddress >> 8) And &HFF)
                                    WriteControlBuffer(2) = (ReadDataByteAddress And &HFF)

                                    ftStatus = I2C_Read(ftHandleThread, WriteControlBuffer, 3, True, 20, DataReadType, ReadDataBuffer, NumDataBytesToRead)

                                    If (ftStatus = FTC_SUCCESS) Then
                                        If (DataReadType = BYTE_READ_TYPE) Then
                                            ReadData(ReadDataByteAddress) = ReadDataBuffer(0)
                                        Else
                                            For ReadDataIndex = 0 To (MAX_I2C_24LC16B_CHIP_SIZE_IN_BYTES - 1)
                                                ReadData(ReadDataIndex) = ReadDataBuffer(ReadDataIndex)
                                            Next
                                        End If

                                        If (DataReadType = BYTE_READ_TYPE) Then
                                            ReadDataByteAddress = ReadDataByteAddress + 1
                                        Else
                                            ReadDataByteAddress = ReadDataByteAddress + MAX_I2C_24LC16B_CHIP_SIZE_IN_BYTES
                                        End If
                                    End If
                                Loop While ((ReadDataByteAddress < MAX_I2C_24LC16B_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                                'Console.WriteLine("Second thread - values read from EEPROM.")

                                If (ftStatus = FTC_SUCCESS) Then
                                    ReadDataIndex = 0

                                    Do
                                        If (DataByte <> 0) Then
                                            DataByteWritten = DataByte
                                        Else
                                            DataByteWritten = (ReadDataIndex And &HFF)
                                        End If

                                        If (((ReadData(ReadDataIndex) <> DataByteWritten) And (DataByte <> 0)) Or ((ReadData(ReadDataIndex) <> DataByteWritten) And (DataByte = 0))) Then
                                            For CharCntr = 0 To (100 - 1)
                                                WriteDataBuffer(CharCntr) = 0
                                            Next

                                            mismatchMsg = String.Format("24LC16B Read/Write mismatch, Address = {0}, Write Value = {1}, Read Value = {2}", ReadDataIndex, DataByteWritten, ReadData(ReadDataIndex))

                                            response = MsgBox(mismatchMsg, style, "I2C Read Error Message")
                                        End If

                                        ReadDataIndex = ReadDataIndex + 1
                                    Loop While ((ReadDataIndex < MAX_I2C_24LC16B_CHIP_SIZE_IN_BYTES) And (response = MsgBoxResult.Ok))
                                End If

                                iLoopCntr = iLoopCntr + 1
                            Loop While ((iLoopCntr < 10) And (ftStatus = FTC_SUCCESS) And (response = MsgBoxResult.Ok))
                        End If
                    End If
                End If
            End If
        End If

        If (ftHandleThread <> 0) Then
            I2C_Close(ftHandleThread)
            ftHandleThread = 0

            'Console.WriteLine("Second thread - device closed.")
        End If

        If ((ftStatus <> FTC_SUCCESS) Or (NumHiSpeedDevices = 0) Or (mismatchMsg <> vbNullString)) Then
            If (ftStatus <> FTC_SUCCESS) Then
                ErrorMessage = "Second Thread - Status Code(" + ftStatus.ToString + ") - "

                ftStatus = I2C_GetErrorCodeString("EN", ftStatus, StatusErrorMessage, MAX_NUM_ERROR_MESSAGE_CHARS)

                ErrorMessage = ErrorMessage + New String(ConvertDLLStringToVBString(StatusErrorMessage))
            Else
                If (NumHiSpeedDevices = 0) Then
                    ErrorMessage = "Second Thread - There are no devices connected."
                Else
                    ErrorMessage = mismatchMsg
                End If
            End If

            MsgBox(ErrorMessage)

            Console.WriteLine("Fail - " + ErrorMessage)
        Else
            MsgBox("Second Thread - Pass")
        End If

        'Application.ExitThread()
    End Sub

    Private Sub TestButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TestButton.Click
        Dim ftStatus As Integer = FTC_SUCCESS
        Dim ftHandle As Integer = 0
        Dim NumHiSpeedDevices As Long = 0
        Dim HiSpeedDeviceName As String = New String(ChrW(0), MAX_NUM_DEVICE_NAME_CHARS)
        Dim HiSpeedDeviceChannel As String = New String(ChrW(0), MAX_NUM_CHANNEL_CHARS)
        Dim LocationID As Long = 0
        Dim HiSpeedDeviceType As Long = 0
        Dim HSDN As String
        Dim HSCH As String
        Dim HiSpeedDeviceIndex As Long = 0
        Dim TimerValue As Byte = 0
        Dim bLoopbackState As Boolean = False
        Dim LowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS = New FTC_INPUT_OUTPUT_PINS
        Dim HighInputOutputPinsData As FTH_INPUT_OUTPUT_PINS = New FTH_INPUT_OUTPUT_PINS
        Dim LowPinsInputData As FTC_LOW_HIGH_PINS = New FTC_LOW_HIGH_PINS
        Dim HighPinsInputData As FTH_LOW_HIGH_PINS = New FTH_LOW_HIGH_PINS
        Dim CloseFinalStatePinsData As FTC_CLOSE_FINAL_STATE_PINS
        Dim DataWriteType As Integer
        Dim WriteDataByteAddress As Integer
        Dim WriteControlBuffer() As Byte = New Byte((WRITE_CONTROL_BUFFER_SIZE - 1)) {}
        Dim DataByte As Byte = 0
        Dim WriteDataBuffer() As Byte = New Byte((WRITE_DATA_BUFFER_SIZE - 1)) {}
        Dim NumDataBytesToWrite As Integer = 0
        Dim WriteDataBufferIndex As Integer = 0
        Dim PageWriteData As FTC_PAGE_WRITE_DATA
        Dim ReadDataBuffer() As Byte = New Byte((READ_DATA_BUFFER_SIZE - 1)) {}
        Dim ReadData() As Byte = New Byte((READ_DATA_BUFFER_SIZE - 1)) {}
        Dim ReadDataIndex As Integer = 0
        Dim ReadDataByteAddress As Integer = 0
        Dim DataReadType As Integer = 0
        Dim NumDataBytesToRead As Long = 0
        Dim MsgBoxKeyPressed As Integer = 0
        Dim DataByteWritten As Byte = 0
        Dim CharCntr As Integer = 0
        Dim iLoopCntr As Integer = 0
        Dim mismatchMsg As String = vbNullString
        Dim style As MsgBoxStyle = MsgBoxStyle.OkCancel
        Dim response As MsgBoxResult = MsgBoxResult.Ok

        Dim StatusErrorMessage As String = New String(ChrW(0), MAX_NUM_ERROR_MESSAGE_CHARS)
        Dim ErrorMessage As String

        Me.GPIOL1InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOL2InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOL3InputLowHighReadStateCheckBox.Checked = False

        Me.GPIOH0InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH1InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH2InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH3InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH4InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH5InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH6InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH7InputLowHighReadStateCheckBox.Checked = False

        Dim DllVersion As String = New String(ChrW(0), MAX_NUM_DLL_VERSION_CHARS)
        ftStatus = GetDllVersion(DllVersion, MAX_NUM_DLL_VERSION_CHARS)
        Me.DLLVersionLabel.Text = Dll_Version_Label + DllVersion
        Me.DLLVersionLabel.Refresh()
        'MsgBox(DllVersion)

        Me.DeviceNameLabel.Text = Device_Name_Label
        Me.DeviceNameLabel.Refresh()

        Me.FT2232HRadioButton.Checked = CheckState.Unchecked
        Me.FT4232HRadioButton.Checked = CheckState.Unchecked

        Me.PassFailResultsStatusLabel.Text = ""
        Me.PassFailureStatusStrip.Refresh()
        Sleep(1000)

        If (Me.MultipleThreadingCheckBox.Checked = True) Then
            Dim newThread As Thread = New Thread(AddressOf ThreadProc)
            ' Start ThreadProc.  Note that on a uniprocessor, the new thread does not
            ' get any processor time until the main thread is preempted or yields.
            ' Uncomment the Thread.Sleep that follows t.Start() to see the difference.
            newThread.Start()
            'Thread.Sleep(0)
        End If

        ftStatus = I2C_GetNumHiSpeedDevices(NumHiSpeedDevices)

        'Console.WriteLine("Main thread get number of devices.")

        If ((ftStatus = FTC_SUCCESS) And (NumHiSpeedDevices > 0)) Then
            Do
                ftStatus = I2C_GetHiSpeedDeviceNameLocIDChannel(HiSpeedDeviceIndex, HiSpeedDeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID, HiSpeedDeviceChannel, MAX_NUM_CHANNEL_CHARS, HiSpeedDeviceType)

                If (ftStatus = FTC_SUCCESS) Then
                    HSCH = New String(ConvertDLLStringToVBString(HiSpeedDeviceChannel))
                End If

                HiSpeedDeviceIndex = HiSpeedDeviceIndex + 1
            Loop While ((ftStatus = FTC_SUCCESS) And (HiSpeedDeviceIndex < NumHiSpeedDevices) And ((HSCH <> vbNullString) And (HSCH <> Me.ChannelComboBox.Text)))

            If (ftStatus = FTC_SUCCESS) Then
                If ((HSCH <> vbNullString) And (HSCH <> Me.ChannelComboBox.Text)) Then
                    ftStatus = FTC_DEVICE_IN_USE
                End If
            End If

            If (ftStatus = FTC_SUCCESS) Then
                HSDN = New String(ConvertDLLStringToVBString(HiSpeedDeviceName))
                ftStatus = I2C_OpenHiSpeedDevice(HSDN, LocationID, HSCH, ftHandle)

                'Console.WriteLine("Main thread opened device.")

                Me.DeviceNameLabel.Text = Device_Name_Label + HSDN
                Me.DeviceNameLabel.Refresh()

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_GetHiSpeedDeviceType(ftHandle, HiSpeedDeviceType)

                    If (ftStatus = FTC_SUCCESS) Then
                        If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT4232H_Device_Type) Then
                            Me.FT4232HRadioButton.Checked = CheckState.Checked 'True
                        ElseIf (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                            Me.FT2232HRadioButton.Checked = CheckState.Checked 'True
                        End If
                    End If
                End If
            End If

            If ((ftHandle <> 0) And (ftStatus = FTC_SUCCESS)) Then
                ftStatus = I2C_InitDevice(ftHandle, MAX_FREQ_M24C64_CLOCK_DIVISOR)

                If (ftStatus = FTC_SUCCESS) Then
                    'ftStatus = I2C_TurnOnThreePhaseDataClockingHiSpeedDevice(ftHandle)

                    'ftStatus = I2C_TurnOffThreePhaseDataClockingHiSpeedDevice(ftHandle)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_GetDeviceLatencyTimer(ftHandle, TimerValue)

                    If (ftStatus = FTC_SUCCESS) Then
                        ftStatus = I2C_SetDeviceLatencyTimer(ftHandle, 50)

                        If (ftStatus = FTC_SUCCESS) Then
                            ftStatus = I2C_GetDeviceLatencyTimer(ftHandle, TimerValue)

                            ftStatus = I2C_SetDeviceLatencyTimer(ftHandle, 16)

                            ftStatus = I2C_GetDeviceLatencyTimer(ftHandle, TimerValue)
                        End If
                    End If
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = TestHiSpeedDeviceClock(ftHandle)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_SetLoopback(ftHandle, False)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_SetMode(ftHandle, FAST_MODE)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    LowInputOutputPinsData.bPin2InputOutputState = Me.GPIOL1InputOutputInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin2LowHighState = Me.GPIOL1OutputLowHighInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin3InputOutputState = Me.GPIOL2InputOutputInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin3LowHighState = Me.GPIOL2OutputLowHighInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin4InputOutputState = Me.GPIOL3InputOutputInitialStateCheckBox.Checked
                    LowInputOutputPinsData.bPin4LowHighState = Me.GPIOL3OutputLowHighInitialStateCheckBox.Checked

                    If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                        ' Set the 8 general purpose higher input/output pins has to input or output
                        HighInputOutputPinsData.bPin1InputOutputState = Me.GPIOH0InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin1LowHighState = Me.GPIOH0OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin2InputOutputState = Me.GPIOH1InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin2LowHighState = Me.GPIOH1OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin3InputOutputState = Me.GPIOH2InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin3LowHighState = Me.GPIOH2OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin4InputOutputState = Me.GPIOH3InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin4LowHighState = Me.GPIOH3OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin5InputOutputState = Me.GPIOH4InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin5LowHighState = Me.GPIOH4OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin6InputOutputState = Me.GPIOH5InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin6LowHighState = Me.GPIOH5OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin7InputOutputState = Me.GPIOH6InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin7LowHighState = Me.GPIOH6OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin8InputOutputState = Me.GPIOH7InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin8LowHighState = Me.GPIOH7OutputLowHighInitialStateCheckBox.Checked

                        ftStatus = I2C_SetHiSpeedDeviceGPIOs(ftHandle, True, LowInputOutputPinsData, True, HighInputOutputPinsData)
                    Else
                        ftStatus = I2C_SetHiSpeedDeviceGPIOs(ftHandle, True, LowInputOutputPinsData, False, HighInputOutputPinsData)
                    End If

                    'Console.WriteLine("Main thread set GPIOs.")

                    If (ftStatus = FTC_SUCCESS) Then
                        Sleep(20)

                        If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                            ftStatus = I2C_GetHiSpeedDeviceGPIOs(ftHandle, True, LowPinsInputData, True, HighPinsInputData)
                        Else
                            ftStatus = I2C_GetHiSpeedDeviceGPIOs(ftHandle, True, LowPinsInputData, False, HighPinsInputData)
                        End If

                        If (ftStatus = FTC_SUCCESS) Then
                            Me.GPIOL1InputLowHighReadStateCheckBox.Checked = LowPinsInputData.bPin2LowHighState
                            Me.GPIOL2InputLowHighReadStateCheckBox.Checked = LowPinsInputData.bPin3LowHighState
                            Me.GPIOL3InputLowHighReadStateCheckBox.Checked = LowPinsInputData.bPin4LowHighState

                            If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                                Me.GPIOH0InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin1LowHighState
                                Me.GPIOH1InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin2LowHighState
                                Me.GPIOH2InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin3LowHighState
                                Me.GPIOH3InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin4LowHighState
                                Me.GPIOH4InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin5LowHighState
                                Me.GPIOH5InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin6LowHighState
                                Me.GPIOH6InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin7LowHighState
                                Me.GPIOH7InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin8LowHighState
                            End If
                        End If
                    End If
                End If

                If ((ftStatus = FTC_SUCCESS) And (Me.GPIOL1To3GPIOH0To7OnlyCheckBox.Checked = False)) Then

                    'WriteControlBuffer(0) = &HAE '1 0 1 0 A2 A1 A0 0 - device address 7
                    WriteControlBuffer(0) = &HA2 '1 0 1 0 A2 A1 A0 0 - device address 1

                    WriteDataBuffer(0) = &HFF  ' Erase address locations

                    WriteDataByteAddress = 0

                    Do
                        ' shift down by 8 bits
                        WriteControlBuffer(1) = ((WriteDataByteAddress >> 8) And &HFF)
                        WriteControlBuffer(2) = (WriteDataByteAddress And &HFF)

                        ftStatus = I2C_Write(ftHandle, WriteControlBuffer, 3, True, 20, True, BYTE_WRITE_TYPE, WriteDataBuffer, 1, True, 20, PageWriteData)

                        WriteDataByteAddress = WriteDataByteAddress + 1
                    Loop While ((WriteDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))
                End If

                'Console.WriteLine("Main thread - erased EEPROM.")

                If ((ftStatus = FTC_SUCCESS) And (Me.GPIOL1To3GPIOH0To7OnlyCheckBox.Checked = False)) Then
                    'WriteControlBuffer(0) = &HAE '1 0 1 0 A2 A1 A0 0 - device address 7
                    WriteControlBuffer(0) = &HA2 '1 0 1 0 A2 A1 A0 0 - device address 1

                    WriteDataByteAddress = 0

                    DataWriteType = BYTE_WRITE_TYPE 'PAGE_WRITE_TYPE ';

                    DataByte = &H77

                    If (DataWriteType = BYTE_WRITE_TYPE) Then
                        WriteDataBuffer(0) = DataByte

                        NumDataBytesToWrite = 1
                    Else
                        WriteDataBuffer(0) = DataByte

                        PageWriteData.NumPages = NUM_M24C64_PAGES
                        PageWriteData.NumBytesPerPage = NUM_M24C64_BYTES_PER_PAGE

                        NumDataBytesToWrite = (NUM_M24C64_PAGES * NUM_M24C64_BYTES_PER_PAGE)

                        For WriteDataBufferIndex = 0 To (NumDataBytesToWrite - 1)
                            WriteDataBuffer(WriteDataBufferIndex) = DataByte
                        Next
                    End If

                    Do
                        ' performs an arithmetic right shift down by 8 bits
                        WriteControlBuffer(1) = ((WriteDataByteAddress >> 8) And &HFF)
                        WriteControlBuffer(2) = (WriteDataByteAddress And &HFF)

                        ftStatus = I2C_Write(ftHandle, WriteControlBuffer, 3, True, 20, True, DataWriteType, WriteDataBuffer, NumDataBytesToWrite, True, 20, PageWriteData)

                        If (DataWriteType = BYTE_WRITE_TYPE) Then
                            WriteDataByteAddress = WriteDataByteAddress + 1
                        Else
                            WriteDataByteAddress = WriteDataByteAddress + (NUM_M24C64_PAGES * NUM_M24C64_BYTES_PER_PAGE)
                        End If
                    Loop While ((WriteDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                    'Console.WriteLine("Main thread - values written to EEPROM.")

                    If (ftStatus = FTC_SUCCESS) Then
                        Do
                            'WriteControlBuffer(0) = &HAF '1 0 1 0 A2 A1 A0 1 - device address 7
                            WriteControlBuffer(0) = &HA3 '1 0 1 0 A2 A1 A0 1 - device address 1

                            For ReadDataIndex = 0 To (MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES - 1)
                                ReadData(ReadDataIndex) = 0
                            Next

                            ReadDataByteAddress = 0

                            DataReadType = BYTE_READ_TYPE 'BLOCK_READ_TYPE '

                            If (DataReadType = BYTE_READ_TYPE) Then
                                NumDataBytesToRead = 1
                            Else
                                NumDataBytesToRead = MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES
                            End If

                            Do
                                ' shift down by 8 bits
                                WriteControlBuffer(1) = ((ReadDataByteAddress >> 8) And &HFF)
                                WriteControlBuffer(2) = (ReadDataByteAddress And &HFF)

                                ftStatus = I2C_Read(ftHandle, WriteControlBuffer, 3, True, 20, DataReadType, ReadDataBuffer, NumDataBytesToRead)

                                If (ftStatus = FTC_SUCCESS) Then
                                    If (DataReadType = BYTE_READ_TYPE) Then
                                        ReadData(ReadDataByteAddress) = ReadDataBuffer(0)
                                    Else
                                        For ReadDataIndex = 0 To (MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES - 1)
                                            ReadData(ReadDataIndex) = ReadDataBuffer(ReadDataIndex)
                                        Next
                                    End If

                                    If (DataReadType = BYTE_READ_TYPE) Then
                                        ReadDataByteAddress = ReadDataByteAddress + 1
                                    Else
                                        ReadDataByteAddress = ReadDataByteAddress + MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES
                                    End If
                                End If
                            Loop While ((ReadDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                            'Console.WriteLine("Main thread - values read from EEPROM.")

                            If (ftStatus = FTC_SUCCESS) Then
                                ReadDataIndex = 0

                                Do
                                    If (DataByte <> 0) Then
                                        DataByteWritten = DataByte
                                    Else
                                        DataByteWritten = (ReadDataIndex And &HFF)
                                    End If

                                    If (((ReadData(ReadDataIndex) <> DataByteWritten) And (DataByte <> 0)) Or ((ReadData(ReadDataIndex) <> DataByteWritten) And (DataByte = 0))) Then
                                        For CharCntr = 0 To (100 - 1)
                                            WriteDataBuffer(CharCntr) = 0
                                        Next

                                        mismatchMsg = String.Format("M24C64 Read/Write mismatch, Address = {0}, Write Value = {1}, Read Value = {2}", ReadDataIndex, DataByteWritten, ReadData(ReadDataIndex))

                                        response = MsgBox(mismatchMsg, style, "I2C Read Error Message")
                                    End If

                                    ReadDataIndex = ReadDataIndex + 1
                                Loop While ((ReadDataIndex < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (response = MsgBoxResult.Ok))
                            End If

                            iLoopCntr = iLoopCntr + 1
                        Loop While ((iLoopCntr < 10) And (ftStatus = FTC_SUCCESS) And (response = MsgBoxResult.Ok))
                    End If
                End If
            End If
        End If

        If (ftHandle <> 0) Then
            'CloseFinalStatePinsData.bTCKPinState = True
            'CloseFinalStatePinsData.bTCKPinActiveState = False
            'CloseFinalStatePinsData.bTDIPinState = True
            'CloseFinalStatePinsData.bTDIPinActiveState = True
            'CloseFinalStatePinsData.bTMSPinState = True
            'CloseFinalStatePinsData.bTMSPinActiveState = True

            'ftStatus = I2C_CloseDevice(ftHandle, CloseFinalStatePinsData)

            I2C_Close(ftHandle)
            ftHandle = 0

            'Console.WriteLine("Main thread - device closed.")
        End If

        If ((ftStatus <> FTC_SUCCESS) Or (NumHiSpeedDevices = 0) Or (mismatchMsg <> vbNullString)) Then
            If (ftStatus <> FTC_SUCCESS) Then
                ErrorMessage = "Status Code(" + ftStatus.ToString + ") - "

                ftStatus = I2C_GetErrorCodeString("EN", ftStatus, StatusErrorMessage, MAX_NUM_ERROR_MESSAGE_CHARS)

                ErrorMessage = ErrorMessage + New String(ConvertDLLStringToVBString(StatusErrorMessage))

                MsgBox(ErrorMessage)
            Else
                If (NumHiSpeedDevices = 0) Then
                    ErrorMessage = "There are no devices connected."

                    MsgBox(ErrorMessage)
                Else
                    ErrorMessage = mismatchMsg
                End If
            End If

            Me.PassFailResultsStatusLabel.Text = "Fail - " + ErrorMessage
            Me.PassFailureStatusStrip.Refresh()

            Console.WriteLine("Fail - " + ErrorMessage)
        Else
            Me.PassFailResultsStatusLabel.Text = "Pass"
            Me.PassFailureStatusStrip.Refresh()
        End If

        Beep()
    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = App_Title

        Me.ChannelComboBox.Items.Clear()
        Me.ChannelComboBox.Items.Add("A")
        Me.ChannelComboBox.Items.Add("B")
        Me.ChannelComboBox.Text = "A"
        'Me.ChannelComboBox.SelectedIndex = -1
    End Sub

    Private Sub MainForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Dim ftStatus As Integer = FTC_SUCCESS

        If (ftHandle <> 0) Then
            ftStatus = I2C_Close(ftHandle)

            ftHandle = 0
        End If
    End Sub

    Private Sub GPIOH0InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH0InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH0InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH0OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH0OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH0OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH1InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH1InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH1InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH1OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH1OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH1OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH2InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH2InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH2InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH2OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH2OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH2OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH3InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH3InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH3InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH3OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH3OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH3OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH4InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH4InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH4InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH4OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH4OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH4OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH5InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH5InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH5InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH5OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH5OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH5OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH6InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH6InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH6InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH6OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH6OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH6OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH7InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH7InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH7InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH7OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH7OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH7OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOL1InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOL1InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOL1InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOL1OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOL1OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOL1OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOL2InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOL2InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOL2InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOL2OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOL2OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOL2OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOL3InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOL3InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOL3InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOL3OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOL3OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOL3OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub MultipleThreadingCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MultipleThreadingCheckBox.CheckedChanged
        If (Me.MultipleThreadingCheckBox.Checked = True) Then
            Me.ChannelComboBox.Text = "A"
        End If
    End Sub
End Class
